package ch.unige.solidify.model;

import java.util.Objects;

import org.springframework.hateoas.RepresentationModel;

public class Module extends RepresentationModel<Module> {
  private String name;

  public Module(String name) {
    this.name = name;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }
    if (!(obj instanceof Module)) {
      return false;
    }
    final Module module = (Module) obj;
    return super.equals(module) && Objects.equals(this.name, module.getName());
  }

  public String getName() {
    return this.name;
  }

  @Override
  public int hashCode() {
    return Objects.hash(super.hashCode(), this.name);
  }

  public void setName(String name) {
    this.name = name;
  }
}
